#property copyright "DoJo"
#property link      ""

#include <stdlib.mqh>
#include <WinUser32.mqh>

// exported variables
extern double BuyLots5 = 0.1;
extern int BuyStoploss5 = 20;
extern int BuyTakeprofit5 = 30;
extern double SellLots10 = 0.1;
extern int SellStoploss10 = 20;
extern int SellTakeprofit10 = 30;


// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
string LF = "\n";  // use this in custom or utility blocks where you need line feeds
int NDigits = 4;   // used mostly for NormalizeDouble in Flex type blocks
int ObjCount = 0;  // count of all objects created on the chart, allows creation of objects with unique names
int current = 0;



int init()
{
    NDigits = Digits;
    
    if (false) ObjectsDeleteAll();      // clear the chart
    
    
    Comment("");    // clear the chart
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
    
    OnEveryTick1();
    
}

void OnEveryTick1()
{
    PipValue = 1;
    if (NDigits == 3 || NDigits == 5) PipValue = 10;
    
    TechnicalAnalysis2x13();
    TechnicalAnalysis2x7();
    
}

void TechnicalAnalysis2x13()
{
    if ((iRSI(0,15,7,0,1) < 30) && (iSAR(0,15,0.02,0.02,1) < Ask) && (iRSI(0,15,7,0,0) < 30) && (iSAR(0,15,0.02,0.02,0) < Ask))
    {
        IfOrderDoesNotExist8();
        
    }
}

void IfOrderDoesNotExist8()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_BUY && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        BuyOrder5();
        
    }
}

void BuyOrder5()
{
    double SL = Ask - BuyStoploss5*PipValue*Point;
    if (BuyStoploss5 == 0) SL = 0;
    double TP = Ask + BuyTakeprofit5*PipValue*Point;
    if (BuyTakeprofit5 == 0) TP = 0;
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_BUY, BuyLots5, Ask, 4, 0, 0, "My Expert", 1, 0, Blue);
    else
    ticket = OrderSend(Symbol(), OP_BUY, BuyLots5, Ask, 4, SL, TP, "My Expert", 1, 0, Blue);
    if (ticket > -1)
    {
        if (true)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Blue);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void TechnicalAnalysis2x7()
{
    if ((iSAR(0,15,0.02,0.02,1) > Bid) && (iRSI(0,15,7,0,1) > 70) && (iSAR(0,15,0.02,0.02,0) > Bid) && (iRSI(0,15,7,0,0) > 70))
    {
        IfOrderDoesNotExist9();
        
    }
}

void IfOrderDoesNotExist9()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        SellOrder10();
        
    }
}

void SellOrder10()
{
    double SL = Bid + SellStoploss10*PipValue*Point;
    if (SellStoploss10 == 0) SL = 0;
    double TP = Bid - SellTakeprofit10*PipValue*Point;
    if (SellTakeprofit10 == 0) TP = 0;
    int ticket = -1;
    if (true)
    ticket = OrderSend(Symbol(), OP_SELL, SellLots10, Bid, 4, 0, 0, "My Expert", 1, 0, Red);
    else
    ticket = OrderSend(Symbol(), OP_SELL, SellLots10, Bid, 4, SL, TP, "My Expert", 1, 0, Red);
    if (ticket > -1)
    {
        if (true)
        {
            OrderSelect(ticket, SELECT_BY_TICKET);
            bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), SL, TP, 0, Red);
            if (ret == false)
            Print("OrderModify() error - ", ErrorDescription(GetLastError()));
        }
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}



int deinit()
{
    if (false) ObjectsDeleteAll();
    
    
}

